; ##############################################################################
; ##############################################################################
; ##############################################################################
; BEGRUNG																		
ANZEIGE_BEGRUESSUNG:
	FONT1
	ZEILE0
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	rcall ASCII_TEXT_Z

	ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	rcall ASCII_TEXT_Z

	ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	rcall ASCII_TEXT_Z

	ZEILE6
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	rcall ASCII_TEXT_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HAUPT:
	FONT2
	ZEILE0
	rcall ANZEIGE_ZEIT_KURZ

	ZEILE2
	LDS temp1,(adr_POSITION_SOLL_0)
	LDS temp2,(adr_POSITION_SOLL_1)
	LDS temp3,(adr_POSITION_SOLL_2)
;	rcall ZAHL_TEMP1_2_3

	ZEILE4
	LDS temp1,(adr_POSITION_IST_0)
	LDS temp2,(adr_POSITION_IST_1)
	LDS temp3,(adr_POSITION_IST_2)
;	rcall ZAHL_TEMP1_2_3

	ZEILE6
	rcall ANZEIGE_POSITION
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SYSTEM_MOTOR:
	FONT2
	rcall OLED_CLEAR
	LDS temp1,(adr_GERTRIEBE_L)
	LDS temp2,(adr_GERTRIEBE_H)
	rcall ZAHL_KOMMA2_TEMP1_2

	ZEILE2
	LDS temp1,(adr_KONSTANTE_L)
	LDS temp2,(adr_KONSTANTE_H)
	rcall ZAHL_TEMP1_2

	ZEILE2

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_SYSTEM:
	rcall OLED_CLEAR
	rcall WAIT_100ms

	FONT0
	ZEILE0 
	in temp1,PWM_A_L
	in temp2,PWM_A_H
	rcall ZAHL_TEMP1_2

	in temp1,PWM_B_L
	in temp2,PWM_B_H
	rcall ZAHL_TEMP1_2

	FONT2
	ZEILE2
	LDS temp1,(adr_POSITION_IST_0)
	LDS temp2,(adr_POSITION_IST_1)
	LDS temp3,(adr_POSITION_IST_2)
	rcall ZAHL_TEMP1_2_3

	ZEILE4 
	LDS temp1,(adr_DREHFELD_L)
	LDS temp2,(adr_DREHFELD_H)
	clr temp3
	rcall ZAHL_TEMP1_2_3

	ZEILE6 
	rcall ANZEIGE_POSITION
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_POSITION:
	LDS temp1,(adr_POSITION_IST_0)
	LDS temp2,(adr_POSITION_IST_1)
	LDS temp3,(adr_POSITION_IST_2)
	clr temp4
	mov R0,temp1
	mov R1,temp2
	mov R2,temp3
	mov R3,temp4

	ldi ZL,low (3600-1)	
	ldi ZH,high(3600-1)		
ANZEIGE_GRAD_2:
	add temp1,R0
	adc temp2,R1
	adc temp3,R2
	adc temp4,R4
	sbiw ZL,1	
	brne ANZEIGE_GRAD_2

	ldi temp5,low (37296)
	ldi temp6,high(37296)
	rcall DIVISION_32_16
	rcall ZAHL_KOMMA2_TEMP1_2
	ldi temp,96
	rcall ASCII_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ZEIT_KURZ:
	LDS temp1,(adr_hh)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPELPUNKT
	LDS temp1,(adr_mm)
	rcall ZAHL2_TEMP1
	rcall ASCII_DOPPELPUNKT
	LDS temp1,(adr_ss)
	rcall ZAHL2_TEMP1
	rcall ASCII_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_BETRIEBSSPANNUNG_KURZ:
	LDS temp1,(adr_ADC_BETRIEBSSPANNUNG)
	rcall ZAHL_KOMMA_TEMP1
	ldi temp,'V'
	rcall ASCII_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



