; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
HEX_TEMP1:
	mov temp,temp1				; oberes NIBBLE bearbeiten	
	swap temp					; NIBBLES tausch			
	rcall ZAHL_HEX_UMWANDLUNG	; INP/OUT: temp				
	rcall ASCII_TEMP

	mov temp,temp1				; unteres NIBBLE bearbeiten	
	rcall ZAHL_HEX_UMWANDLUNG	; INP/OUT: temp				
	rcall ASCII_TEMP
	ret
;-------------------------------------------------------------------------------
ZAHL_HEX_UMWANDLUNG:
	andi temp,0b00001111		; BITMUSTER					
	cpi temp,10					; vergleich					
	brsh ZAHL_HEX_UMWANDLUNG_A_F
ZAHL_HEX_UMWANDLUNG_0_9:
	subi temp,-48				; +48	
	ret
ZAHL_HEX_UMWANDLUNG_A_F:
	subi temp,-87				; +
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "12"																		
ZAHL2_TEMP1:
	cpi temp1,99+1	; BERLAUF ?		
	brlo ZAHL2_TEMP1_w2
	rcall ASCII_FRAGEZEICHEN
	rjmp ASCII_FRAGEZEICHEN
;-------------------------------------------------------------------------------
ZAHL2_TEMP1_w2:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp2
	rcall ASCII_TEMP	
	mov temp, temp1
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "012"																	
ZAHL_TEMP1:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9+temp		
	rcall ZAHL_NULLSTELLENUNTERDRUECKUNG
	mov temp, temp3			; 3.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp2			; 2.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall ASCII_TEMP
	rjmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "12.3"																	
ZAHL_KOMMA_TEMP1:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9+temp		
	cpi temp3,'0'
	brne ZAHL_KOMMA_w
	ldi temp3,' '
ZAHL_KOMMA_w:
	mov temp, temp3				; 3.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp2				; 2.ZEICHEN 
	rcall ASCII_TEMP	
	rcall ASCII_PUNKT
	mov temp, temp1				; 1.ZEICHEN (1-er Stelle)	
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "123,45"																	
ZAHL_KOMMA2_TEMP1_2:
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9+temp		
	cpi temp5,'0'
	brne ZAHL_KOMMA_TEMP1_2_w
	ldi temp5,' '
	cpi temp4,'0'
	brne ZAHL_KOMMA_TEMP1_2_w
	ldi temp4,' '
ZAHL_KOMMA_TEMP1_2_w:
	mov temp, temp5				; 5.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp4				; 4.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp3				; 3.ZEICHEN 
	rcall ASCII_TEMP	
	rcall ASCII_PUNKT
	mov temp, temp2				; 2.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp1				; 1.ZEICHEN (1-er Stelle)	
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_TEMP1_2:
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32
	rcall ZAHL_NULLSTELLENUNTERDRUECKUNG
	mov temp, temp5			; 5.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp4			; 4.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp3			; 3.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp2			; 2.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_TEMP1_2_3:
	clr temp4
 	rcall FUNCTION_HEX_ASC_32
	rcall ZAHL_NULLSTELLENUNTERDRUECKUNG
	mov temp, temp8			; 8.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp7			; 7.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp6			; 6.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp5			; 5.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp4			; 4.ZEICHEN 
	rcall ASCII_TEMP
	mov temp, temp3			; 3.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp2			; 2.ZEICHEN 
	rcall ASCII_TEMP	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rjmp ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
;(0...4.294.967.295)															
ZAHL_TEMP1_2_3_4:
 	rcall FUNCTION_HEX_ASC_32
	cpi temp,'0'
	brne ZAHL32_10
	rcall ASCII_SPACE2

	cpi temp9,'0'
	brne ZAHL32_9
	rcall ASCII_SPACE

	cpi temp8,'0'
	brne ZAHL32_8
	rcall ASCII_SPACE

	cpi temp7,'0'
	brne ZAHL32_7
	rcall ASCII_SPACE2

	cpi temp6,'0'
	brne ZAHL32_6
	rcall ASCII_SPACE

	cpi temp5,'0'
	brne ZAHL32_5
	rcall ASCII_SPACE

	cpi temp4,'0'
	brne ZAHL32_4
	rcall ASCII_SPACE

	cpi temp3,'0'
	brne ZAHL32_3
	rcall ASCII_SPACE

	cpi temp2,'0'
	brne ZAHL32_2
	rcall ASCII_SPACE

	rjmp ZAHL32_1
;---------------------------------------------------------------------------
ZAHL32_10:
	rcall ASCII_TEMP	; temp!  10.ZEICHEN 	
	rcall ASCII_PUNKT		; .			
ZAHL32_9:
	mov temp, temp9			; 9.ZEICHEN 
	rcall ASCII_TEMP	
ZAHL32_8:
	mov temp, temp8			; 8.ZEICHEN 
	rcall ASCII_TEMP
ZAHL32_7:
	mov temp, temp7			; 7.ZEICHEN 
	rcall ASCII_TEMP	
	rcall ASCII_PUNKT		; .			
ZAHL32_6:
	mov temp, temp6			; 6.ZEICHEN 
	rcall ASCII_TEMP
ZAHL32_5:
	mov temp, temp5			; 5.ZEICHEN 
	rcall ASCII_TEMP
ZAHL32_4:
	mov temp, temp4			; 4.ZEICHEN 
	rcall ASCII_TEMP
	rcall ASCII_PUNKT		; .			
ZAHL32_3:
	mov temp, temp3			; 3.ZEICHEN 
	rcall ASCII_TEMP	
ZAHL32_2:
	mov temp, temp2			; 2.ZEICHEN 
	rcall ASCII_TEMP	
ZAHL32_1:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	rcall ASCII_TEMP
	rjmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZAHL_NULLSTELLENUNTERDRUECKUNG:
.equ NS=' ' ; Nullstelle	

	cpi temp,'0'
	breq ZAHL_NULL9
	ret
ZAHL_NULL9:
	ldi temp,(NS)	; Nullstelle	
	cpi temp9,'0'
	breq ZAHL_NULL8
	ret
ZAHL_NULL8:
	ldi temp9,(NS)	; Nullstelle	
	cpi temp8,'0'
	breq ZAHL_NULL7
	ret
ZAHL_NULL7:
	ldi temp8,(NS)	; Nullstelle	
	cpi temp7,'0'
	breq ZAHL_NULL6
	ret
ZAHL_NULL6:
	ldi temp7,(NS)	; Nullstelle	
	cpi temp6,'0'
	breq ZAHL_NULL5
	ret
ZAHL_NULL5:
	ldi temp6,(NS)	; Nullstelle	
	cpi temp5,'0'
	breq ZAHL_NULL4
	ret
ZAHL_NULL4:
	ldi temp5,(NS)	; Nullstelle	
	cpi temp4,'0'
	breq ZAHL_NULL3
	ret
ZAHL_NULL3:
	ldi temp4,(NS)	; Nullstelle	
	cpi temp3,'0'
	breq ZAHL_NULL2
	ret
ZAHL_NULL2:
	ldi temp3,(NS)	; Nullstelle	
	cpi temp2,'0'
	breq ZAHL_NULL1
	ret
ZAHL_NULL1:
	ldi temp2,(NS)	; Nullstelle	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2014															
;																			
;	Value: 0...	4.294.967.295 (0xFFFFFFFF)									
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			temp	(1.000.000.000-er Stelle)								
; 																			
FUNCTION_HEX_ASC_32:
	clr temp			
FUNCTION_HEX_ASC_10:	; 1.000.000.000er Stelle
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNCTION_HEX_ASC_10
	subi temp, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNCTION_HEX_ASC_9:	; 100.000.000er Stelle
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNCTION_HEX_ASC_9
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNCTION_HEX_ASC_8:	; 10.000.000er Stelle
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNCTION_HEX_ASC_8
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNCTION_HEX_ASC_7:	; 1.000.000er Stelle
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNCTION_HEX_ASC_7
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_6:	; 100.000er Stelle
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_6
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNCTION_HEX_ASC_5:	; 10.000er Stelle
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNCTION_HEX_ASC_5
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNCTION_HEX_ASC_4:	; 1.000er Stelle
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNCTION_HEX_ASC_4
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNCTION_HEX_ASC_3:	; 100er Stelle
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNCTION_HEX_ASC_3
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNCTION_HEX_ASC_2:	; 10er Stelle
	inc temp2
	subi temp1, low  (10)
	brcc FUNCTION_HEX_ASC_2
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNCTION_HEX_ASC_1:	; 1er Stelle
	subi temp1, -48		; HEX->ASC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

